#!/bin/sh -e
# Copyright (C) @BABOLO  2008 Sep 20
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.1 2008/09/21 00:09:38 babolo Exp $

genclass=spamd
suffix=
inclass=spamassassin
. ${JAILUP_CONF}
kind=`${dirname} "${0}"`
kind=`${basename} "${kind}"`
t=`${basename} "${0}"`
if  [ "${t}" != "${t#*-}" ]; then
    kind="${kind}/-${t#*-}"
fi

if  [ -z "${1}" ]; then
    ${cat} << EOF
# jailup ${inclass} dir jailname jailaddr
#     where jailname - hostname for jail (see jail(2) hostname)
#           jailaddr - IP addr for jail (see jail(2) ip_number)
#           dir - relative to ${JAILUPDIR} and ${JAILRODIR}
# installed ports/mail/p5-Mail-SpamAssassin used
EOF
    exit
fi
umask 022

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
perl=perl5.8.8

main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}"
${up_mdir} "${main_dir}" ${MTREE}
${up_mdir} "${conf_dir}" ${MTREE}-conf

ETCOPY(resolv.conf localtime protocols)

${up_ldsh} << EOF | ${up_shlib} "${main_dir}/usr/lib"
    /usr/local/bin/${perl}
EOF

${up_libexe} "${main_dir}/usr/libexec" << EOF
    ld-elf.so.1
    /usr/local/bin/${perl}
    /usr/local/bin/spamd
EOF
      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
ppath=`${perl} -e 'for($i=1;$i<10;$i++){last if(@INC[$i]eq".");last if(@INC[$i]eq"");print @INC[$i]."\n";}'`
${up_genlist} usr/site_perl/ ${MTREE} | ${up_arb} pm "${main_dir}/usr/site_perl" "${ppath}"
  ${up_genlist} ${inclass}/ ${MTREE}-conf\
| ${up_data} "${conf_dir}/${inclass}/" "${PREFIX}/etc/mail/${inclass}/" "${PREFIX}/share/${inclass}/"

${up_ponf} "${conf_dir}/group" <<- "EOF"
	wheel:*:0:root
	spamd:*:7833:
EOF

${up_ponf} "${conf_dir}/master.passwd" <<- "EOF"
	root:*:0:0::0:0:Charlie &:/:/nonexistent
	spamd:*:7833:7833::0:0:SpamAssassin:/tmp:/nonexistent
EOF

${cat} <<- EOF >> "${etcdir}/newsyslog.conf"
	#${main_dir}/var/log/${inclass}	644  9     *	@T00  Z ${main_dir}/var/run/${inclass}.pid
EOF

${cat} <<- EOF >> "${genconfig}"
	#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	7833	7833	7833
EOF
      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${up_mtree} "${main_dir}" ${MTREE}
${mtree} -Ueqxp "${conf_dir}" -f ${MTREE}-conf
${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"
      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${cat} <<- EOF >> "${etcdir}/fstab"
	#/null			${main_dir}/dev	null	ro,noexec	0 0
	#${conf_dir}		${main_dir}/etc	null	ro,nodev,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
